// +build !linux

package singlepoll

import (
	"context"
	"errors"

	"gx/ipfs/QmeoWapXvjjwRqLczX6ufvPTk6w8xzso35AoYNa8PRrDKs/go-reuseport/poll"
)

var (
	ErrUnsupportedMode error = errors.New("only 'w' mode is supported on this arch")
)

func PollPark(ctx context.Context, fd int, mode string) error {
	if mode != "w" {
		return ErrUnsupportedMode
	}

	p, err := poll.New(fd)
	if err != nil {
		return err
	}
	defer p.Close()

	return p.WaitWriteCtx(ctx)
}
